package com.test.webservice.regard;

import java.util.Iterator;
import java.util.List;

import org.opencms.file.CmsObject;
import org.opencms.file.CmsUser;
import org.opencms.main.CmsException;
import org.opencms.main.OpenCms;
import org.opencms.security.CmsOrgUnitManager;

/**
 * Clase que implementa el servicio web.
 */
public class RegardServiceImpl implements RegardService {

    /**
     * Atributo cmsObject, para poder operar sobre el contexto de OpenCms
     */
    private CmsObject cmsObject;

    /**
     * Metodo que dado el login de un usuario indica si esta
     * registrado en OpenCms o no.
     */
    public boolean sayHello(String userLogin) {
        // Variable que indica si el usuario esta registrado en OpenCms
        boolean isUser = false;

        // Inicializamos el CmsObject
        initCmsObject();

        // Comprobamos si el usuario es valido
        if (userLogin != null) {
            CmsOrgUnitManager orgUnitManager = OpenCms.getOrgUnitManager();

            // Obtenemos todos los usuarios de la unidad organizativa raiz
            List users;
            try {
                users = orgUnitManager.getUsers(cmsObject, "/", true);

                Iterator itUsers = users.iterator();

                // Declaramos un objeto sobre el vamos a obtener
                // los usuarios en el recorrido.
                CmsUser user;

                // Recorremos todos los usuarios
                while (itUsers.hasNext() && !isUser) {
                    // Obtenemos el usuario.
                    user = (CmsUser) itUsers.next();

                    // Comprobamos si coincide el login
                    if (user.getName().equals(userLogin)) {
                        isUser = true;
                    }
                }
            } catch (CmsException e) {
                e.printStackTrace();
            }
        }

        return isUser;
    }

    /**
     * Metodo que inicializa el atributo cmsObject
     */
    private void initCmsObject() {
        try {
            this.cmsObject = OpenCms.initCmsObject("Export");
        } catch (CmsException e) {
            e.printStackTrace();
        }
    }
}